Restore Debian's init.d script for insserv compatibility

Bug #1323274 reported by Martin Pitt on 2014-05-26
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
alsa-utils (Ubuntu)
Undecided
Dimitri John Ledkov
debhelper (Ubuntu)
Undecided
Dimitri John Ledkov
dovecot (Ubuntu)
Undecided
Martin Pitt
kbd (Ubuntu)
Low
Unassigned
kde-workspace (Ubuntu)
Undecided
Martin Pitt
lvm2 (Ubuntu)
Undecided
Unassigned
mythtv-status (Ubuntu)
Undecided
Unassigned
network-manager (Ubuntu)
Undecided
Martin Pitt
nfs-utils (Ubuntu)
Undecided
Martin Pitt
sqcwa (Ubuntu)
Undecided
Unassigned
squid-prefetch (Ubuntu)
Undecided
Unassigned
squid3 (Ubuntu)
Undecided
Martin Pitt
systemd (Ubuntu)
Undecided
Martin Pitt

Bug Description

We want/need to follow Debian's migration from static rc?.d/ priorities to dynamic insserv priorities. See https://code.launchpad.net/~ubuntu-core-dev/ubuntu/utopic/sysvinit/unreviewed/+merge/219999 for details.

This is a tracking bug for all Ubuntu init.d scripts that have LSB header dependencies to init.d scripts which are in Debian, but not in Ubuntu. E. g.

/etc/init.d/mpd:# Should-Start: autofs $network $named alsa-utils pulseaudio avahi-daemon

But there is no /etc/init.d/alsa-utils in the Ubuntu package.

- greylistd is a false positive (changed recently)
- cman (src:redhat-cluster) does not exist at all in Ubuntu, so we need to drop/fix its init.d dependencies.
- chef-server script comes from chef-server-api which is stuck in -proposed due to uninstallability

Martin Pitt (pitti) on 2014-05-26
Changed in dovecot (Ubuntu):
assignee: nobody → Martin Pitt (pitti)
Martin Pitt (pitti) wrote :

Dimitri is working on updating dh_installinit to add the required upstart versioned dependency to misc:Depends.

Changed in debhelper (Ubuntu):
assignee: nobody → Dimitri John Ledkov (xnox)
status: New → In Progress
Changed in dovecot (Ubuntu):
status: New → In Progress
Martin Pitt (pitti) wrote :

utopic/etc/init.d/mythtv-status:# Should-Start: $named mythtv-backend motd
utopic/etc/init.d/mythtv-status:# Should-Stop: $named mythtv-backend motd

This is a bit special as we intentionally did not bring back /etc/init.d/motd as motd generation works differently on Ubuntu. This needs to ship a script in /etc/update-motd.d/ instead.

Martin Pitt (pitti) on 2014-05-26
description: updated
Martin Pitt (pitti) on 2014-05-26
description: updated
Changed in debhelper (Ubuntu):
status: In Progress → Fix Committed
Changed in network-manager (Ubuntu):
assignee: nobody → Martin Pitt (pitti)
status: New → In Progress
Martin Pitt (pitti) wrote :

We don't have a direct counterpart of /etc/init.d/kbd, as console setup is completely different on Ubuntu. All mentions of that are only "Should-Start/Stop", so it won't actually break anything. We should still eventually fix it of course.

Changed in kbd (Ubuntu):
importance: Undecided → Low
status: New → Triaged
Martin Pitt (pitti) wrote :

We don't have /etc/init.d/mdadm-raid as we build MD arrays with udev rules. Therefore our /etc/init.d/udev should Provides: that (this script calls udevadm settle).

affects: mdadm (Ubuntu) → systemd (Ubuntu)
Changed in systemd (Ubuntu):
assignee: nobody → Martin Pitt (pitti)
status: New → In Progress
Martin Pitt (pitti) wrote :

lvm2 is similar to mdadm, will add a Provides: to udev.init.

Changed in lvm2 (Ubuntu):
status: New → Invalid
Changed in dovecot (Ubuntu):
status: In Progress → Fix Committed
Martin Pitt (pitti) on 2014-05-26
Changed in network-manager (Ubuntu):
status: In Progress → Fix Committed
Martin Pitt (pitti) on 2014-05-26
Changed in systemd (Ubuntu):
status: In Progress → Fix Committed
Changed in alsa-utils (Ubuntu):
assignee: nobody → Dimitri John Ledkov (xnox)
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package debhelper - 9.20140228ubuntu2

---------------
debhelper (9.20140228ubuntu2) utopic; urgency=medium

  * Add upstart versioned dependency on upstart that provides lsb hook, to
    make sure sourcing lsb init-functions triggers transparent launching
    of the upstart job instead. (LP: #1323274).
 -- Dimitri John Ledkov <email address hidden> Mon, 26 May 2014 14:39:04 +0200

Changed in debhelper (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package dovecot - 1:2.2.9-1ubuntu4

---------------
dovecot (1:2.2.9-1ubuntu4) utopic; urgency=medium

  * Rename init.d script to work with the dh_installinit --name option, so
    that it comes back. (LP: #1323274)
 -- Martin Pitt <email address hidden> Mon, 26 May 2014 14:24:43 +0200

Changed in dovecot (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package network-manager - 0.9.8.8-0ubuntu17

---------------
network-manager (0.9.8.8-0ubuntu17) utopic; urgency=medium

  * Merge Debian's init script, for compatibility with insserv.
    (LP: #1323274)
 -- Martin Pitt <email address hidden> Mon, 26 May 2014 15:35:25 +0200

Changed in network-manager (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package systemd - 204-10ubuntu5

---------------
systemd (204-10ubuntu5) utopic; urgency=medium

  * Make udev.init provide "mdadm-raid", "lvm", and "lvm2", as Ubuntu
    assembles MD and LVM devices via udev rules instead of init scripts.
    (LP: #1323274)
 -- Martin Pitt <email address hidden> Mon, 26 May 2014 15:49:15 +0200

Changed in systemd (Ubuntu):
status: Fix Committed → Fix Released
Martin Pitt (pitti) on 2014-05-26
affects: squid (Ubuntu) → squid3 (Ubuntu)
Changed in squid3 (Ubuntu):
assignee: nobody → Martin Pitt (pitti)
status: New → In Progress
Martin Pitt (pitti) wrote :

Removing packages from utopic:
 squid-prefetch 1.1-3 in utopic
  squid-prefetch 1.1-3 in utopic amd64
  squid-prefetch 1.1-3 in utopic arm64
  squid-prefetch 1.1-3 in utopic armhf
  squid-prefetch 1.1-3 in utopic i386
  squid-prefetch 1.1-3 in utopic powerpc
  squid-prefetch 1.1-3 in utopic ppc64el
Comment: does not work with squid3, orphaned in Debian

Changed in squid-prefetch (Ubuntu):
status: New → Fix Released
Martin Pitt (pitti) wrote :

emoving packages from utopic:
 sqcwa 0.3-3.1 in utopic
  sqcwa 0.3-3.1 in utopic amd64
  sqcwa 0.3-3.1 in utopic arm64
  sqcwa 0.3-3.1 in utopic armhf
  sqcwa 0.3-3.1 in utopic i386
  sqcwa 0.3-3.1 in utopic powerpc
  sqcwa 0.3-3.1 in utopic ppc64el
Comment: does not work with squid3, removed from Debian testing, unmaintained

Changed in sqcwa (Ubuntu):
status: New → Fix Released
Martin Pitt (pitti) on 2014-05-26
Changed in squid3 (Ubuntu):
status: In Progress → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package squid3 - 3.3.8-1ubuntu7

---------------
squid3 (3.3.8-1ubuntu7) utopic; urgency=medium

  * Put back the init.d script, for compatibility with insserv. (LP: #1323274)
 -- Martin Pitt <email address hidden> Mon, 26 May 2014 23:27:57 +0200

Changed in squid3 (Ubuntu):
status: Fix Committed → Fix Released
David Henningsson (diwic) wrote :

> /etc/init.d/mpd:# Should-Start: autofs $network $named alsa-utils pulseaudio avahi-daemon
> But there is no /etc/init.d/alsa-utils in the Ubuntu package.

Not exactly sure what this means, is this related to the relatively new daemon functionality of alsactl?
So far we have avoided starting that daemon by default because (by my judgement) the overhead of having yet another daemon everywhere weighs heavier than the minimal functionality it provides in very few configurations.

Martin Pitt (pitti) on 2014-05-27
Changed in kde-workspace (Ubuntu):
assignee: nobody → Martin Pitt (pitti)
status: New → In Progress

Hey David,

David Henningsson [2014-05-27 6:42 -0000]:
> Not exactly sure what this means, is this related to the relatively
> new daemon functionality of alsactl? So far we have avoided
> starting that daemon by default because (by my judgement) the
> overhead of having yet another daemon everywhere weighs heavier than
> the minimal functionality it provides in very few configurations.

Sorry, this probably was confusing to everyone except Dimitri and me.
The goal here is merely to make Ubuntu compatible to insserv. In
particular, any declared LSB dependency in our init.d scripts actually
needs to exist. But we don't want to change actual behaviour, i. e. in
this case we will put back the alsa-utils init.d script for insserv to
be able to compute dependencies, but we'll also add an alsa-utils
upstart job which is a no-op (similar to the systemd alsa-utils unit
which is also just a /dev/null).

Martin Pitt (pitti) wrote :

mythtv-status' dependency to "motd" is only a "Should", which won't break the dependency calculation. So no need to change anything here and carry around a delta.

Changed in mythtv-status (Ubuntu):
status: New → Won't Fix
Martin Pitt (pitti) wrote :

Likewise, kbd only has reverse "Should" starts, so that won't break dependency calculation.

Changed in kbd (Ubuntu):
status: Triaged → Won't Fix
Changed in kde-workspace (Ubuntu):
status: In Progress → Fix Committed
David Henningsson (diwic) wrote :

> Sorry, this probably was confusing to everyone except Dimitri and me.
> The goal here is merely to make Ubuntu compatible to insserv. In
> particular, any declared LSB dependency in our init.d scripts actually
> needs to exist. But we don't want to change actual behaviour, i. e. in
> this case we will put back the alsa-utils init.d script for insserv to
> be able to compute dependencies, but we'll also add an alsa-utils
> upstart job which is a no-op (similar to the systemd alsa-utils unit
> which is also just a /dev/null).

For me it would probably be less confusing to fix mpd (and possibly others) to not depend on alsa-utils, instead of adding no-op jobs and service files...?

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package alsa-utils - 1.0.27.2-1ubuntu3

---------------
alsa-utils (1.0.27.2-1ubuntu3) utopic; urgency=medium

  * Add alsa-utils compatibility job for startpar (equivalent of /dev/null
    symlink of the systemd unit). (LP: #1323274)
 -- Dimitri John Ledkov <email address hidden> Tue, 27 May 2014 08:45:11 +0200

Changed in alsa-utils (Ubuntu):
status: New → Fix Released
Martin Pitt (pitti) wrote :

David Henningsson [2014-05-27 8:27 -0000]:
> For me it would probably be less confusing to fix mpd (and possibly
> others) to not depend on alsa-utils, instead of adding no-op jobs and
> service files...?

Maybe, but these have a tendency to come back through syncs and
merges. We'll have an overall lower data if we just stop dropping the
init.d scripts and make sure that our init.d and upstart jobs are
Debian policy compliant.

Martin Pitt (pitti) on 2014-05-27
Changed in nfs-utils (Ubuntu):
assignee: nobody → Martin Pitt (pitti)
status: New → Fix Committed
Martin Pitt (pitti) on 2014-05-27
tags: added: block-proposed
Martin Pitt (pitti) on 2014-05-27
tags: removed: block-proposed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package nfs-utils - 1:1.2.8-6ubuntu3

---------------
nfs-utils (1:1.2.8-6ubuntu3) utopic; urgency=medium

  * Soon nfs-common.init is going to be split on the Debian side, and
    nfs-kernel-server init.d's LSB depends on "nfs-common" has never done
    anything in Ubuntu. Drop it to avoid breaking insserv. (LP: #1323274)
 -- Martin Pitt <email address hidden> Tue, 27 May 2014 11:38:51 +0200

Changed in nfs-utils (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package kde-workspace - 4:4.11.9-0ubuntu3

---------------
kde-workspace (4:4.11.9-0ubuntu3) utopic; urgency=medium

  * Put back the init.d script for compatibility with insserv. (LP: #1323274)
 -- Martin Pitt <email address hidden> Tue, 27 May 2014 08:35:35 +0200

Changed in kde-workspace (Ubuntu):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers